% La fonction "annale06_q2_v1" répond à la seconde question de l'exercice
% #6 de l'annale 2012, en utilisant la variable de contrôle |y|. Son
% interface avec l'utilisateur est la même que pour "annale06_q1".
function annale06_q2_v1(N)
% le 2-vecteur "T" désigne les coordonnées du point T.
T = [1,0];
% "Sf" contiendra la somme des simulations de la quantité dont on cherche à
% évaluer l'espérance (généralement appelée f dans le cours).
Sf = 0;
% "S2f" contiendra la somme des carrés de f.
S2f = 0;
% "Sg" contiendra la somme des simulations de la variable de contrôle
% (généralement appelée g dans le cours).
Sg = 0;
% "S2g" contiendra la somme des carrés de g.
S2g = 0;
% "Sfg" contiendra la somme des produits fg, en vue d'évauer Cov(f,g).
Sfg = 0;
% On lance la boucle de simulations.
for i = 1:N
    % Le 2-vecteur "X" contient les coordonnées du point simulé X.
    X = randn(1,2);
    % f est la quantité dont on cherche à évaluer l'espérance, à savoir la
    % distance entre X et T.
    f = sqrt(sum((T-X).^2));
    % g est la variable de contrôle.
    g = abs(X(2));
    % On met à jour les différentes sommes.
    Sf = Sf + f;
    S2f = S2f + f * f;
    Sg = Sg + g;
    S2g = S2g + g * g;
    Sfg = Sfg + f * g;
end
% "mf" est la moyenne empirique des f.
mf = Sf / N;
% "mg" est la moyenne empirique des g.
mg = Sg / N;
% "Varf" est la variance (empirique) de f.
Varf = S2f / N - mf * mf;
% "Varg" est la variance (empirique) de g.
Varg = S2g / N - mg * mg;
% "Covfg" est la covariance (empirique) de f et g.
Covfg = Sfg / N - mf * mg;
% "lambda" est (l'évaluation empirique de) le lambda optimal.
lambda = Covfg / Varg;
% "esperance" est l'estimateur de E(f-lambda*g).
esperance = mf - lambda * mg;
% "variance" est la variance (empirique) de f-lambda*g.
variance = Varf - 2 * lambda * Covfg + lambda * lambda * Varg;
% "erreur" est la marge d'erreur sur l'estimateur de E(f-lambda*g), qui
% sera aussi celle sur l'estimateur de E(f) une fois qu'on ajoura ajouté
% lambda*E(g).
erreur = 2 * sqrt(variance) / sqrt(N);
% "Eg" est l'espérance *exacte* de g, dont on a calculé l'expression
% théoriquement (calcul intégral tout bête en utilisant que y suit la loi
% normale centrée réduite et en décomposant l'intégrale de |y| sur R_- et
% R_+).
Eg = 2 / sqrt(2 * pi);
% "D" est l'estimateur de E(f) utilisant la variable de contrôle.
D = esperance + lambda * Eg;
% On affiche le résultat.
disp(['Distance moyenne : ',num2str(D),' ± ',num2str(erreur)]);
% Affin de bien comprendre les arcanes de ce qui s'est passé, on affiche
% aussi la valeur de "lambda".
disp(['Pour info : le lambda optimal valait environ ',num2str(lambda)]);
return
end